#ifndef FIGURE_HPP
#define FIGURE_HPP

#include <memory>

//demonstracja wzorca prototypu dla przedmiotu ZPR 2023Z
namespace zpr {

	class Figure;
	using PFigure = std::unique_ptr<Figure>;

	class Figure {
	public:
		virtual PFigure clone() const = 0;

		//symuluje wyswietlanie figury
		virtual void draw() const = 0;

		virtual ~Figure() {}
	};

	class Rect : public Figure {
	public:
		PFigure clone() const override { return PFigure(new Rect); }
		void draw() const override;
	};

	class Circle : public Figure {
	public:
		PFigure clone() const override { return PFigure(new Circle); }
		void draw() const override;
	};
}
#endif //FIGURE_HPP
